# PhasicFlow: Map< Key, T, Compare > Class Template Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

Map< Key, T, Compare > Class Template Reference
Inheritance diagram for Map< Key, T, Compare >:
[legend]
Collaboration diagram for Map< Key, T, Compare >:
[legend]

## Public Types

using | MapType = Map< Key, T, Compare >
using | mapType = std::map< Key, T, Compare >
using | iterator = typename mapType::iterator
using | constIterator = typename mapType::const_iterator
using | reference = typename mapType::reference
using | constReference = typename mapType::const_reference
using | initList = typename std::initializer_list< T >
using | keyType = typename mapType::key_type
using | mappedType = typename mapType::mapped_type
using | valueType = typename mapType::value_type

## Public Member Functions

| TypeInfoTemplateNV11 ("Map", Key)
| Map ()
| Map (initList lst)
| Map (const MapType &src)
| Map (MapType &&src)
MapType & | operator= (const MapType &rhs)
MapType & | operator= (MapType &&rhs)
uniquePtr< MapType > | clone () const
MapType * | clonePtr () const
| ~Map ()
bool | insertIf (const keyType &k, const mappedType &v)
bool | insertIf (keyType &&k, mappedType &&v)
bool | search (const keyType k) const
std::pair< iterator, bool > | findIf (const keyType &k)
const std::pair< constIterator, bool > | findIf (const keyType &k) const

## Detailed Description

### template<class Key, class T, class Compare = std::less<Key>>
class pFlow::Map< Key, T, Compare >

Definition at line 36 of file Map.hpp.

## Member Typedef Documentation

## MapType

using MapType = Map<Key, T, Compare>

Definition at line 42 of file Map.hpp.

## mapType

using mapType = std::map<Key, T, Compare>

Definition at line 44 of file Map.hpp.

## iterator

using iterator = typename mapType::iterator

Definition at line 46 of file Map.hpp.

## constIterator

using constIterator = typename mapType::const_iterator

Definition at line 48 of file Map.hpp.

## reference

using reference = typename mapType::reference

Definition at line 50 of file Map.hpp.

## constReference

using constReference = typename mapType::const_reference

Definition at line 52 of file Map.hpp.

## initList

using initList = typename std::initializer_list<T>

Definition at line 54 of file Map.hpp.

## keyType

using keyType = typename mapType::key_type

Definition at line 56 of file Map.hpp.

## mappedType

using mappedType = typename mapType::mapped_type

Definition at line 58 of file Map.hpp.

## valueType

using valueType = typename mapType::value_type

Definition at line 60 of file Map.hpp.

## Constructor & Destructor Documentation

## Map() [1/4]

Map | ( |  | ) |

inline

Definition at line 68 of file Map.hpp.

## Map() [2/4]

Map | ( | initList | lst | ) |

inline

Definition at line 72 of file Map.hpp.

## Map() [3/4]

Map | ( | const MapType & | src | ) |

inline

Definition at line 78 of file Map.hpp.

## Map() [4/4]

Map | ( | MapType && | src | ) |

inline

Definition at line 84 of file Map.hpp.

## ~Map()

~Map | ( |  | ) |

inline

Definition at line 113 of file Map.hpp.

## Member Function Documentation

## TypeInfoTemplateNV11()

TypeInfoTemplateNV11 | ( | "Map< Key, T, Compare >" | ,
|  | Key |
| ) |  |

## operator=() [1/2]

MapType& operator= | ( | const MapType & | rhs | ) |

inline

Definition at line 90 of file Map.hpp.

## operator=() [2/2]

MapType& operator= | ( | MapType && | rhs | ) |

inline

Definition at line 97 of file Map.hpp.

## clone()

uniquePtr<MapType> clone | ( |  | ) | const

inline

Definition at line 103 of file Map.hpp.

## clonePtr()

MapType* clonePtr | ( |  | ) | const

inline

Definition at line 108 of file Map.hpp.

## insertIf() [1/2]

bool insertIf | ( | const keyType & | k,
|  | const mappedType & | v
| ) |  |

Definition at line 23 of file MapI.hpp.

Referenced by fileSeries::addTimeFile(), and pFlow::getTimeFolders().

Here is the caller graph for this function:

## insertIf() [2/2]

bool insertIf | ( | keyType && | k,
|  | mappedType && | v
| ) |  |

Definition at line 30 of file MapI.hpp.

## search()

bool search | ( | const keyType | k | ) | const

Definition at line 40 of file MapI.hpp.

## findIf() [1/2]

std::pair< typename pFlow::Map< Key, T, Compare >::iterator, bool > findIf | ( | const keyType & | k | ) |

Definition at line 47 of file MapI.hpp.

## findIf() [2/2]

const std::pair< typename pFlow::Map< Key, T, Compare >::constIterator, bool > findIf | ( | const keyType & | k | ) | const

Definition at line 56 of file MapI.hpp.

The documentation for this class was generated from the following files:

- src/phasicFlow/containers/Map/Map/Map.hpp
- src/phasicFlow/containers/Map/Map/MapI.hpp